X2Go Bug report logs - #142
x2goclient output on stdout

version graph

Package: x2goclient; Maintainer for x2goclient is X2Go Developers <x2go-dev@lists.x2go.org>; Source for x2goclient is src:x2goclient.

Reported by: Kjell Otto <otto.kjell@gmail.com>

Date: Thu, 7 Mar 2013 13:03:02 UTC

Severity: normal

Tags: patch, pending

Found in version 4.0.0.4

Fixed in version 4.0.1.1

Done: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#142; Package x2goclient. (Thu, 07 Mar 2013 13:03:02 GMT) (full text, mbox, link).


Acknowledgement sent to Kjell Otto <otto.kjell@gmail.com>:
New Bug report received and forwarded. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Thu, 07 Mar 2013 13:03:02 GMT) (full text, mbox, link).


Message #5 received at submit@bugs.x2go.org (full text, mbox, reply):

From: Kjell Otto <otto.kjell@gmail.com>
To: submit@bugs.x2go.org
Subject: x2goclient output on stdout
Date: Thu, 7 Mar 2013 13:51:25 +0100
Package: x2goclient
Version: 4.0.0.4

The x2goclient has extreme output on stdout while running. It's more
noise then signal and therefor, I've wrapped all the printouts with
#ifdef DEBUG and a #undef DEBUG on the onmainwindow.cpp file.

Then I've added in printout statements that are parsable with numbered
output and category so that a normal run of the x2goclient would
output like this:

$ ./client_build/x2goclient --session=x2goserver_RZ --add-to-known-hosts --hide
x2go-INFO-001> Starting x2goclient...
x2go-WARN-001> Can't load translator: :/x2goclient_en_us
x2go-WARN-002> Can't load translator: :/qt_en_US
x2go-INFO-004> Started  x2goclient.
x2go-INFO-005> $HOME=/home/kjellski
x2go-INFO-029> Starting connection to server: 10.3.0.20:22
x2go-INFO-031> SSH connection established.
x2go-INFO-011> Closing x2goclient...
x2go-INFO-018> Waiting for the SSH connection to finish...
x2go-INFO-019> Waited  for the SSH connection to finish.
x2go-INFO-028> Closed  x2goclient.
$

No GUI will be shown and no try Icons appear. This reflects a bit more
the --hide param and can be used to make a shortcut to the client that
will just open the window.

Also I've added a log method and provided a script that lets you show
all outputs on the file.

All changes can be found on this repository in the branch stdout-cleanup:

https://github.com/kjellski/x2goclient/tree/stdout-cleanup

If any additional help from my side is required, please contact me and
I try to support the process.

Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#142; Package x2goclient. (Thu, 07 Mar 2013 15:18:01 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Thu, 07 Mar 2013 15:18:01 GMT) (full text, mbox, link).


Message #10 received at 142@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Kjell Otto <otto.kjell@gmail.com>, 142@bugs.x2go.org
Cc: control@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#142: x2goclient output on stdout
Date: Thu, 07 Mar 2013 16:08:49 +0100
[Message part 1 (text/plain, inline)]
Hi Otto,

On Do 07 Mär 2013 13:51:25 CET Kjell Otto wrote:

> Package: x2goclient
>
> The x2goclient has extreme output on stdout while running. It's more
> noise then signal and therefor, I've wrapped all the printouts with
> #ifdef DEBUG and a #undef DEBUG on the onmainwindow.cpp file.
>
> Then I've added in printout statements that are parsable with numbered
> output and category so that a normal run of the x2goclient would
> output like this:
>
> $ ./client_build/x2goclient --session=x2goserver_RZ  
> --add-to-known-hosts --hide
> x2go-INFO-001> Starting x2goclient...
> x2go-WARN-001> Can't load translator: :/x2goclient_en_us
> x2go-WARN-002> Can't load translator: :/qt_en_US
> x2go-INFO-004> Started  x2goclient.
> x2go-INFO-005> $HOME=/home/kjellski
> x2go-INFO-029> Starting connection to server: 10.3.0.20:22
> x2go-INFO-031> SSH connection established.
> x2go-INFO-011> Closing x2goclient...
> x2go-INFO-018> Waiting for the SSH connection to finish...
> x2go-INFO-019> Waited  for the SSH connection to finish.
> x2go-INFO-028> Closed  x2goclient.
> $
>
> No GUI will be shown and no try Icons appear. This reflects a bit more
> the --hide param and can be used to make a shortcut to the client that
> will just open the window.
>
> Also I've added a log method and provided a script that lets you show
> all outputs on the file.
>
> All changes can be found on this repository in the branch stdout-cleanup:
>
> https://github.com/kjellski/x2goclient/tree/stdout-cleanup
>
> If any additional help from my side is required, please contact me and
> I try to support the process.

yes, help is required.

1. Create fresh (tmp) branch
2. pull over your patches you wish applied in x2goclient.git
3. rebase, boil all single commits down to one commit
4. send the URL to the exact patch/diff for review

Mike



-- 

DAS-NETZWERKTEAM
mike gabriel, rothenstein 5, 24214 neudorf-bornstein
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#142; Package x2goclient. (Mon, 11 Mar 2013 13:03:01 GMT) (full text, mbox, link).


Acknowledgement sent to Kjell Otto <otto.kjell@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 11 Mar 2013 13:03:02 GMT) (full text, mbox, link).


Message #15 received at 142@bugs.x2go.org (full text, mbox, reply):

From: Kjell Otto <otto.kjell@gmail.com>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Cc: 142@bugs.x2go.org, control@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#142: x2goclient output on stdout
Date: Mon, 11 Mar 2013 13:51:28 +0100
[Message part 1 (text/plain, inline)]
Hi Mike,

here is my patch boiled down to one commit. You can look at it before
you apply it here:
https://github.com/kjellski/x2goclient/compare/master...debug-cleanup

Greetings,
Kjellski

2013/3/7 Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
> Hi Otto,
>
> On Do 07 Mär 2013 13:51:25 CET Kjell Otto wrote:
>
>> Package: x2goclient
>>
>>
>> The x2goclient has extreme output on stdout while running. It's more
>> noise then signal and therefor, I've wrapped all the printouts with
>> #ifdef DEBUG and a #undef DEBUG on the onmainwindow.cpp file.
>>
>> Then I've added in printout statements that are parsable with numbered
>> output and category so that a normal run of the x2goclient would
>> output like this:
>>
>> $ ./client_build/x2goclient --session=x2goserver_RZ --add-to-known-hosts
>> --hide
>> x2go-INFO-001> Starting x2goclient...
>> x2go-WARN-001> Can't load translator: :/x2goclient_en_us
>> x2go-WARN-002> Can't load translator: :/qt_en_US
>> x2go-INFO-004> Started  x2goclient.
>> x2go-INFO-005> $HOME=/home/kjellski
>> x2go-INFO-029> Starting connection to server: 10.3.0.20:22
>> x2go-INFO-031> SSH connection established.
>> x2go-INFO-011> Closing x2goclient...
>> x2go-INFO-018> Waiting for the SSH connection to finish...
>> x2go-INFO-019> Waited  for the SSH connection to finish.
>> x2go-INFO-028> Closed  x2goclient.
>> $
>>
>> No GUI will be shown and no try Icons appear. This reflects a bit more
>> the --hide param and can be used to make a shortcut to the client that
>> will just open the window.
>>
>> Also I've added a log method and provided a script that lets you show
>> all outputs on the file.
>>
>> All changes can be found on this repository in the branch stdout-cleanup:
>>
>> https://github.com/kjellski/x2goclient/tree/stdout-cleanup
>>
>> If any additional help from my side is required, please contact me and
>> I try to support the process.
>
>
> yes, help is required.
>
> 1. Create fresh (tmp) branch
> 2. pull over your patches you wish applied in x2goclient.git
> 3. rebase, boil all single commits down to one commit
> 4. send the URL to the exact patch/diff for review
>
> Mike
>
>
>
> --
>
> DAS-NETZWERKTEAM
> mike gabriel, rothenstein 5, 24214 neudorf-bornstein
> fon: +49 (1520) 1976 148
>
> GnuPG Key ID 0x25771B31
> mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de
>
> freeBusy:
> https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[0001-Added-the-debug-parameter-to-x2goclient.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#142; Package x2goclient. (Mon, 11 Mar 2013 21:33:01 GMT) (full text, mbox, link).


Acknowledgement sent to Kjell Otto <otto.kjell@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Mon, 11 Mar 2013 21:33:01 GMT) (full text, mbox, link).


Message #20 received at 142@bugs.x2go.org (full text, mbox, reply):

From: Kjell Otto <otto.kjell@gmail.com>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Cc: 142@bugs.x2go.org, control@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#142: x2goclient output on stdout
Date: Mon, 11 Mar 2013 22:18:40 +0100
[Message part 1 (text/plain, inline)]
Hi Mike,

unfortunatly, I seem to have missed a bug that was introduced by this
patch regarding windows builds.
Since I was testing and releasing everything under linux and mac, I
missed it in the first patch. I'm really
sorry for this. Please find the corrected patch attached.

The issue was caused by, patch applied, line 9055 which was then
trying to access undefined variables.
I seem to have falsely uncommented the line while correcting the other
printouts:

@@ -8833,7 +9051,9 @@ void ONMainWindow::startWinServers()
         startPulsed();
     }
 // #ifdef CFGCLIENT
-//     x2goDebug<<"xorg settings: "<<startXorgOnStart <<" "<< useXming<<endl;
+
+    //x2goDebug<<"Xorg settings: "<< startXorgOnStart <<" useXming:
"<< useXming;
+
     if ( useInternalX && (internalX== XMING))
     {
 // #endif

Before, the patch was uncommenting the line above, which was wrong.

I was now able to build the client under windows and linux, and mac :)

Greetings,
Kjellski


2013/3/11 Kjell Otto <otto.kjell@gmail.com>:
> Hi Mike,
>
> here is my patch boiled down to one commit. You can look at it before
> you apply it here:
> https://github.com/kjellski/x2goclient/compare/master...debug-cleanup
>
> Greetings,
> Kjellski
>
> 2013/3/7 Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
>> Hi Otto,
>>
>> On Do 07 Mär 2013 13:51:25 CET Kjell Otto wrote:
>>
>>> Package: x2goclient
>>>
>>>
>>> The x2goclient has extreme output on stdout while running. It's more
>>> noise then signal and therefor, I've wrapped all the printouts with
>>> #ifdef DEBUG and a #undef DEBUG on the onmainwindow.cpp file.
>>>
>>> Then I've added in printout statements that are parsable with numbered
>>> output and category so that a normal run of the x2goclient would
>>> output like this:
>>>
>>> $ ./client_build/x2goclient --session=x2goserver_RZ --add-to-known-hosts
>>> --hide
>>> x2go-INFO-001> Starting x2goclient...
>>> x2go-WARN-001> Can't load translator: :/x2goclient_en_us
>>> x2go-WARN-002> Can't load translator: :/qt_en_US
>>> x2go-INFO-004> Started  x2goclient.
>>> x2go-INFO-005> $HOME=/home/kjellski
>>> x2go-INFO-029> Starting connection to server: 10.3.0.20:22
>>> x2go-INFO-031> SSH connection established.
>>> x2go-INFO-011> Closing x2goclient...
>>> x2go-INFO-018> Waiting for the SSH connection to finish...
>>> x2go-INFO-019> Waited  for the SSH connection to finish.
>>> x2go-INFO-028> Closed  x2goclient.
>>> $
>>>
>>> No GUI will be shown and no try Icons appear. This reflects a bit more
>>> the --hide param and can be used to make a shortcut to the client that
>>> will just open the window.
>>>
>>> Also I've added a log method and provided a script that lets you show
>>> all outputs on the file.
>>>
>>> All changes can be found on this repository in the branch stdout-cleanup:
>>>
>>> https://github.com/kjellski/x2goclient/tree/stdout-cleanup
>>>
>>> If any additional help from my side is required, please contact me and
>>> I try to support the process.
>>
>>
>> yes, help is required.
>>
>> 1. Create fresh (tmp) branch
>> 2. pull over your patches you wish applied in x2goclient.git
>> 3. rebase, boil all single commits down to one commit
>> 4. send the URL to the exact patch/diff for review
>>
>> Mike
>>
>>
>>
>> --
>>
>> DAS-NETZWERKTEAM
>> mike gabriel, rothenstein 5, 24214 neudorf-bornstein
>> fon: +49 (1520) 1976 148
>>
>> GnuPG Key ID 0x25771B31
>> mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de
>>
>> freeBusy:
>> https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[0001-Added-the-debug-parameter-to-x2goclient.patch (application/octet-stream, attachment)]

Added tag(s) patch. Request was from mike@das-netzwerkteam.de (Mike Gabriel) to control@bugs.x2go.org. (Sun, 21 Apr 2013 23:32:38 GMT) (full text, mbox, link).


Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#142; Package x2goclient. (Sat, 18 May 2013 18:48:02 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Sat, 18 May 2013 18:48:02 GMT) (full text, mbox, link).


Message #27 received at 142@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 142-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 142@bugs.x2go.org
Subject: X2Go issue (in src:x2goclient) has been marked as pending for release
Date: Sat, 18 May 2013 20:47:38 +0200 (CEST)
tag #142 pending
fixed #142 4.0.1.1
thanks

Hello,

X2Go issue #142 (src:x2goclient) reported by you has been
fixed in X2Go Git. You can see the changelog below, and you can
check the diff of the fix at:

    http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=a657ff6

The issue will most likely be fixed in src:x2goclient (4.0.1.1).

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
commit a657ff6df33de369f4c323e42b642b157d999b45
Author: Otto Kjell <otto.kjell@gmail.com>
Date:   Sat May 18 20:22:54 2013 +0200

    Enable debug mode through cmd line parameter. (Fixes: #142).

diff --git a/debian/changelog b/debian/changelog
index d06914d..85111fe 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -12,6 +12,10 @@ x2goclient (4.0.1.1-0~x2go1) UNRELEASED; urgency=low
       Let's consider a given SSH private key that fails to log the user
       in as an overall login failure. (Fixes: #141).
 
+  [ Otto Kjell ]
+  * New upstream version (4.0.1.1):
+    - Enable debug mode through cmd line parameter. (Fixes: #142).
+
   [ Orion Poplawski ]
   * New upstream version (4.0.1.1):
     - Instead of using a hard-code DPI of 96, use local DPI settings for new


Added tag(s) pending. Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Sat, 18 May 2013 18:48:02 GMT) (full text, mbox, link).


Marked as fixed in versions 4.0.1.1. Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Sat, 18 May 2013 18:48:02 GMT) (full text, mbox, link).


Message sent on to Kjell Otto <otto.kjell@gmail.com>:
Bug#142. (Sat, 18 May 2013 18:48:03 GMT) (full text, mbox, link).


Information forwarded to x2go-dev@lists.berlios.de, X2Go Developers <x2go-dev@lists.berlios.de>:
Bug#142; Package x2goclient. (Wed, 11 Sep 2013 10:18:02 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.berlios.de>. (Wed, 11 Sep 2013 10:18:02 GMT) (full text, mbox, link).


Message #39 received at 142@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 142-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 142@bugs.x2go.org
Subject: X2Go issue (in src:x2goclient) has been marked as closed
Date: Wed, 11 Sep 2013 12:07:07 +0200 (CEST)
close #142
thanks

Hello,

we are very hopeful that X2Go issue #142 reported by you
has been resolved in the new release (4.0.1.1) of the
X2Go source project »src:x2goclient«.

You can view the complete changelog entry of src:x2goclient (4.0.1.1)
below, and you can use the following link to view all the code changes
between this and the last release of src:x2goclient.

    http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=dad4fcc24868504be24ccc9a3ab0fcac41859080;hp=1b4260f86a6fda01c5263fa3d27504677a3cdfac

If you feel that the issue has not been resolved satisfyingly, feel
free to reopen this bug report or submit a follow-up report with
further observations described based on the new released version
of src:x2goclient.

Thanks a lot for contributing to X2Go!!!

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
X2Go Component: src:x2goclient
Version: 4.0.1.1
Status: RELEASE
Date: Wed, 11 Sep 2013 12:06:02 +0200
Fixes: 141 142 151 164 165 177 179 183 214 222 226 243 255
Changes: 
 x2goclient (4.0.1.1) RELEASED; urgency=low
 .
   [ Nicolai Hansen ]
   * New upstream version (4.0.1.1):
     - Update Danish translation file.
 .
   [ Terje Andersen ]
   * New upstream version (4.0.1.1):
     - Update Norwegian Bokmaal translation file.
 .
   [ Oleksandr Shneyder ]
   * New upstream version (4.0.1.1):
     - Use "127.0.0.1" instead of localhost to avoid wrong IPv6 hostname
       resolution. (Fixes: #151).
     - Wait for x2gocmdexitmessage to return before closing in hidden mode.
     - Support for published applications in X2Go Plugin
     - Support for "shadow" mode in X2Go Plugin
 .
   [ Mike Gabriel ]
   * New upstream version (4.0.1.1):
     - If a priv SSH key has been specified, skip the autologin procedure.
       Let's consider a given SSH private key that fails to log the user
       in as an overall login failure. (Fixes: #141).
     - Avoid multiple selectUserSession requests when in broker
       mode.
     - Properly set the remote server address received via selectUserSession
       method when in broker mode. (Fixes: #226).
     - Fix segmentation fault that started occurring since the custom trayIcon
       patch was applied. Segfault only occurred if the tray icon was not used.
     - Show session name in notification bubbles.
     - Update German translation.
     - Add cmdline option --broker-autologoff: Enforce re-authentication against
       X2Go Session Broker after a session has been suspended or terminated.
       (Fixes: #179).
     - Enable full access desktop sharing across user accounts. (Fixes: #222).
     - Make X2Go Client aware of the MATE desktop environment.
     - Make X2Go Client work in SSH broker mode without the need of a auth-id
       file.
 .
   [ Heinrich Schuchardt ]
   * New upstream version (4.0.1.1):
     - Call ssh_clean_pubkey_hash() for deallocating public key hashes instead of
       just calling free(). Required under MS Windows as documented in libssh2
       API. (Fixes: #243). (For further details see:
       http://api.libssh.org/master/group__libssh__session.html).
   * Provide bin:package with debug symbols for X2Go Client. (Fixes: #255).
 .
   [ Ezra Bühler ]
   * New upstream version (4.0.1.1):
     - Fix auto-resume when session type is »Single Application«. (Fixes: #183).
 .
   [ Ricardo Díaz Martín ]
   * New upstream version (4.0.1.1):
     - Fix detection of maximum screen area available for a session. (Fixes:
       #165).
     - Use the session icon as tray icon, pop up notification bubble that informs
       about current session actions. (Fixes: #177).
     - Allow for setting maximum available desktop size as window size via the
       session profile card. Unfortunately, this feature is for now only
       available on Linux. (Fixes: #214).
 .
   [ Otto Kjell ]
   * New upstream version (4.0.1.1):
     - Enable debug mode through cmd line parameter. (Fixes: #142).
     - Standardize output to stdout+stderr and make it parseable.
 .
   [ Orion Poplawski ]
   * New upstream version (4.0.1.1):
     - Instead of using a hard-code DPI of 96, use local DPI settings for new
       sessions if not explicitly set in session profile (Fixes: #164).
 .
   [ Daniel Lindgren ]
   * New upstream version (4.0.1.1):
     - Update Swedish translation file.
 .
   [ Ricardo Díaz Martín ]
   * New upstream version (4.0.1.1):
     - Update Spanish translation file.


Marked Bug as done Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Wed, 11 Sep 2013 10:18:14 GMT) (full text, mbox, link).


Notification sent to Kjell Otto <otto.kjell@gmail.com>:
Bug acknowledged by developer. (Wed, 11 Sep 2013 10:18:14 GMT) (full text, mbox, link).


Message sent on to Kjell Otto <otto.kjell@gmail.com>:
Bug#142. (Wed, 11 Sep 2013 10:18:15 GMT) (full text, mbox, link).


Bug archived. Request was from Debbugs Internal Request <owner@bugs.x2go.org> to internal_control@bugs.x2go.org. (Thu, 10 Oct 2013 05:24:02 GMT) (full text, mbox, link).


Send a report that this bug log contains spam.


X2Go Developers <owner@bugs.x2go.org>. Last modified: Tue Dec 10 03:11:29 2019; Machine Name: ymir.das-netzwerkteam.de

X2Go Bug tracking system

Debbugs is free software and licensed under the terms of the GNU Public License version 2. The current version can be obtained from https://bugs.debian.org/debbugs-source/.

Copyright © 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson, 2005-2017 Don Armstrong, and many other contributors.